<template>
    <el-container style="padding: 40px 15%;">
        <!-- <el-card></el-card> -->
        <el-card style="width: 100%;">
            <h1 class="title" v-if="type=='image'">发布图文</h1>
            <h1 class="title" v-else-if="type=='video'">发布视频</h1>
            <h1 class="title" v-else>发布帖子</h1>
            <div class="cont">
                <el-form @submit.native.prevent>
                <el-row class="f-title">
                    <el-col :span="3">标题:</el-col>
                    <el-col :span="21">
                        <el-input v-model="upForm.title" show-word-limit placeholder="请输入标题"  size="large" maxlength="30" />
                    </el-col>
                </el-row>
                <el-row class="f-cont">
                    <el-col :span="3">帖子内容:</el-col>
                    <el-col :span="21">
                        <el-input
                        style="font-size: 18px;"
                                v-model="upForm.comment"
                                :rows="6"
                                type="textarea"
                                show-word-limit
                                placeholder="请输入内容"
                                maxlength="120"
                            />
                    </el-col>
                </el-row>
                <el-row v-if="type=='image'">
                    <el-col :span="3">上传图片:</el-col>
                    <el-col :span="21">
                        <!-- <upFile/> -->
                        <!-- <input type="file" ref="file" @change="upd" multiple> -->
                        <input type="file" multiple @change="handleFileChange">
                    </el-col>
                </el-row>
                <el-row v-else-if="type=='video'">
                    <el-col :span="3">上传视频:</el-col>
                    <el-col :span="21">
                        <!-- <upVideo/> -->
                        <input type="file" id="video" @change="handlevideoChange">
                    </el-col>
                </el-row>
                <el-row >
                    <el-col :span="3">选择话题:</el-col>
                    <el-col :span="21">
                        <repSelect ref="reps"/>
                    </el-col>
                </el-row>
                <el-row class="up-btn">
                    <el-col :span="24" >
                        <el-button type="primary" @click="upPost()">发布</el-button>
                    </el-col>
                </el-row>
            </el-form>
            </div>
        </el-card>
    </el-container>
</template>
<script >
import { defineComponent } from 'vue';
import { reactive, ref } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import upFlie from '../../components/upFile.vue'
import upVideo from '../../components/upVideo.vue'
import repSelect from '../../components/repSelect.vue'
import axios from 'axios';
export default {
    components:{
        upFlie,
        upVideo,
        repSelect,
    },
    props: {
        postParams: Object
    },
    mounted() {
    console.log('接收到的参数：', this.$route.params.type)
  },
    setup(props) {
        const route = useRoute();
        const reps = ref(null);
        const type = route.params.type; // 从路由参数中获取id
        const files = ref([])
        // 存储表单数据
        const upForm= ref({
            title:'',
            comment:'',
            topc:'',
        })
        const router = useRouter();
        const videoFile = ref(null)

        const handlevideoChange = (event) => {
        videoFile.value = event.target.files[0]
        }
        const upPost = async ()=>{
            console.log(reps.value.value); 
            const formData = new FormData()

        // 添加帖子参数
        formData.append('title', upForm.value.title)
        formData.append('comment', upForm.value.comment)
        formData.append('user_id', localStorage.getItem("Userid"))
        formData.append('video', videoFile.value)

        // 添加上传的文件
        for (let i = 0; i < files.value.length; i++) {
          formData.append(`file${i}`, files.value[i])
        }

        // 发送 POST 请求
        try {
          const response = await axios.post('/api/schoolCloud/pages/addpost/upimg.php', formData, {
            headers: {
              'Content-Type': 'multipart/form-data'
            }
          })

          ElMessage({
                        message: '发布成功！',
                        type: 'success',
          })
          router.push('/postList')
        } catch (error) {
          console.error(error)
        }
      }
              // console.log();
        const handleFileChange = (event) => {
        files.value = event.target.files
      }
        // const upd = (e)=>{
        //     // console.log(this.$refs.file)
        //     console.log(e.target.files instanceof Array)//false
        //     let file = new FormData()
        //     let arr = Array.from(e.target.files)
        //    for(var i=0;i<arr.length;i++){
        //          file.append('file[]',arr[i])//file[]注意多文件格式 单文件file不需要循环
        //          file.getAll('file');
        //    }
        //    console.log(file.getAll('file'))
        //     axios.post('/api/schoolCloud/pages/addpost/index.php',file,{
        //         headers:{
        //             "content-type":"multipart/form-data"
        //         }
        //     }).then((res) =>{
        //         console.log(res)
        //     })
        // }
        
        // const type = ref('');
        return {
            router,
                reps,
                handleFileChange,
                videoFile,
                handlevideoChange,
                files,
                upPost,
                upForm,
                type,
            }
    },
        
    
}
</script>
<style lang="less" scoped>
.title{
    font-size: 20px;
    padding: 0 20px 15px 10px;
    border-bottom: 1px #e9e9e9 solid;
}
.cont{
    padding: 30px 60px;
    .el-row{
        margin-bottom: 20px;
        .el-col{
            font-size: 18px;
        }
    }
    .up-btn{
        margin-top: 20px;
        .el-col{
            display: flex;
            justify-content: center;
            .el-button{
                width: 210px;
                height: 46px;
            }
        }
    }
    .f-title{
        height: 100px;
        padding: 10px 0;
        .el-col{
            line-height: 100px;
            .el-input{
                height: 60px;
                font-size: 18px;    
            }
        }
    }
}
</style>